
Smart Proxy - Bug #2768

importing classes partially fails when dynamic modulepath has multiple entries

07/10/2013 07:32 AM - David Schmitt

Status: Rejected   

Priority: High   

Assignee:    

Category: Puppet   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Hi,

with an modulepath of the form '/srv/puppet/$environment/modules:/srv/puppet_mac/$environment/modules', the smart proxy will

only see modules from the second component.

Please apply the following patch to fix this:

--- environment.rb.orig    2013-07-10 13:28:19.945539637 +0200

+++ environment.rb.fixed    2013-07-10 13:28:34.508591835 +0200

@@ -75,7 +75,7 @@

               # Dynamic environments - get every directory under the modulepath

               Dir.glob("#{base_dir.gsub(/\$environment(.*)/,"/")}/*").grep(/\/[A-Za-z0-9_]+$/) do

 |dir|

                 e = dir.split("/").last

-                new_env[e.to_sym] = base_dir.gsub("$environment", e)

+                new_env[e.to_sym] = [new_env[e.to_sym], base_dir.gsub("$environment", e)].flatten

.reject{|d|d.nil?}.join(":")

               end

             end

           end

Related issues:

Is duplicate of Foreman - Bug #2738: smart-proxy for puppet not picking up wh... Closed 07/03/2013

History

#1 - 07/10/2013 07:40 AM - Dominic Cleal

- Status changed from New to Feedback

This looks like #2738, could you try that patch please David?  (Or the foreman-proxy nightly, which will have it.)

#2 - 07/10/2013 08:38 AM - David Schmitt

Yeah, #2738 definitely looks like this problem. Looking forward to 1.2.1 :-)

#3 - 07/10/2013 10:04 AM - Dominic Cleal

- Status changed from Feedback to Rejected

- Target version deleted (1.2.1)

Good, thanks for testing.
